<template>
    <div class="prk-order__container prk-order--step-four prk-order__container--shadow">
      <popupEror 
         v-if="responsEror && clousPopup" 
         :eror="responsEror"
         v-on:clous-popup="clousPopup = false;noScroll();"
        />
       <h2 class="prk-order__title">INFORMATIONS SUR LA LIVRAISON ET LE VÉHICULE</h2>
        <ProgressForm
          :currentItem="2"
        />
        <div class="prk-order__form-four">
          <form @submit.stop.prevent>
            <div class="row">
              <div class="col-md-6">
                <label class="prk-order__label">Marque de votre véhicule</label>
                <input 
                  type="text"  
                  name="CarBrand"  
                  v-model.trim="formDataObj.CarBrand" 
                  class="prk-order__input"
                :class="{'prk-order__is-invalid': missingCarBrand && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingCarBrand && attemptSubmit">
                    S'il vous plaît entrer la marque de voiture
                </div>
              </div>
              <div class="col-md-6">
                <label class="prk-order__label">Modèle de votre véhicule</label>
                <input 
                  type="text"  
                  name="CarModel" 
                  v-model.trim="formDataObj.CarModel" 
                  class="prk-order__input"
                  :class="{'prk-order__is-invalid': missingCarModel && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingCarModel && attemptSubmit">
                     S'il vous plaît entrer le modèle de voiture
                </div>
              </div>
              <div class="col-md-6">
                <label class="prk-order__label">Immatriculation</label>
                <input 
                  type="text"  
                  name="Registration" 
                  placeholder=" AA 000 BB" 
                  v-model.trim="formDataObj.Registration" 
                  class="prk-order__input prk-order__input--max-width text-uppercase"
                  :class="{'prk-order__is-invalid': missingRegistration && attemptSubmit}">
                <div class="prk-order__invalid" v-if="missingRegistration && attemptSubmit">
                     S'il vous plaît entrer le immatriculation
                </div>
              </div>
              <div class="col-md-6">
                <label class="prk-order__label">Instructions à communiquer au voiturier</label>
                <textarea name="Comment" v-model.trim="formDataObj.Comment" placeholder="Votre commentaire" class="prk-order__textarea" rows="5"></textarea>
              </div>
            </div>
            <div class="prk-order__action">
              <button 
                type="submit"
                class="prk-order__button prk-order__button--next" 
                :disabled="loadRespons"
                :class="{'prk-order__loader':loadRespons}"
                @click="validateForm();  
                $emit('FormFourVal', formDataObj);">
                AFFICHER LE RÉCAPITULATIF
              </button>
            </div>  
          </form>
        </div>
        <div class="flex justify-content-center">
            <button  class="prk-order__button prk-order__button--no-bg prk-order__button--prev" @click="$emit('prev-step')">REVENIR</button>
        </div>
    </div>
</template>

<script>
import ProgressForm from './ProgressForm.vue'
import popupEror from './popupEror.vue'
import axios from 'axios'
export default {
  name: 'FromStepFour',
  components: {
    ProgressForm,
    popupEror
  },
  data() {
      return {
        attemptSubmit: false,
        loadRespons: null,
        responsEror: false,
        clousPopup: false,
        formDataObj: {
            step: 4,
            CarBrand: '',
            CarModel: '',
            Registration: '',
            Comment: '',
        } 
      }
  },
  methods: {
    validateForm() {
      this.attemptSubmit = true;
      if (this.missingCarBrand || this.missingCarModel || this.missingRegistration){
         return false;
      }else{
        this.loadRespons = true; 
        axios({
          method: 'post',
          url: '/wp-admin/admin-ajax.php',
          timeout: 60000, 
          params: {
             action: 'step_4',
          },
          data: {
            body: JSON.stringify(this.formDataObj),
          }
          })
         .then(response=>{
              if(response.data.error){
                 this.responsEror = response.data.error;
                 this.clousPopup = true;
              }else{
                 this.responsEror = false;
              } 
          })
          .catch(()=>{
                this.responsEror = "Une erreur s'est produite, n'hésitez pas à contacter l'équipe Sales à contact@parkopoly.fr";
                this.clousPopup = true;
          })
          .finally(()=>{
             this.loadRespons = false;
          }); 
        return true;
      }
    },
    noScroll(){
       document.body.classList.remove('scroll-none');
    },
  },
  computed: {
    missingCarBrand(){
       return this.formDataObj.CarBrand === '';
    },
    missingCarModel(){
      return this.formDataObj.CarModel === '';
    },
    missingRegistration(){
      return this.formDataObj.Registration === '';
    },
  },
  watch: {
     loadRespons(){
        return(!this.loadRespons &&  !this.responsEror? this.$emit('next-step'):null);
     }
  },
}
</script>
